START203——Set To Median(sort的魔力) · znzryb
## 思路讲解
注释非常详细,看注释就行。
## AC代码
AC
[https://www.codechef.com/viewsolution/1190317643](https://www.codechef.com/viewsolution/1190317643)
::: 源代码
```cpp
// by Gospel_rock
#include <bits/stdc++.h>
#define all(vec) vec.begin(),vec.end()
#define PB push_back
#define PF push_front
#define EB emplace_back
#define EF emplace_front
#define EM emplace
#define FI first
#define SE second
#define pct __builtin_popcountll
#define ctz __builtin_ctzll
#define lson(o) (o<<1)
#define rson(o) (o<<1|1)
#define SZ(a) ((long long) a.size())
#define FOR(i, a, b) for (int i = (a); i <= (b); ++i)
#define ROF(i, a, b) for (int i = (a); i >= (b); --i)
#define debug(var) cerr << #var <<":"<<var<<"\n";
#define cend cerr<<"\n-----------\n"
#define fsp(x) fixed<<setprecision(x)
#define minn(vec) *min_element(vec.begin(),vec.end())
#define maxx(vec) *max_element(vec.begin(),vec.end())
using namespace std;
#ifdef LOCAL
template<typename T> void _print(T x) {
cerr << x;
}
// 可以打印多层数组,但是格式不是很好
template<typename T> void _print(vector<T> v) {
cerr << "[ ";
for (T i : v) _print(i), cerr << " ";
cerr << "]";
}
template<typename T> void _print(set<T> s) {
cerr << "{ ";
for (T i : s) _print(i), cerr << " ";
cerr << "}";
}
template<typename T, typename U> void _print(pair<T, U> p) {
cerr << "{";
_print(p.first);
cerr << ", ";
_print(p.second);
cerr << "}";
}
template<typename T, typename U> void _print(map<T, U> m) {
cerr << "{ ";
for (auto &p : m) _print(p), cerr << " ";
cerr << "}";
}
// 打印两层数组,格式好一些
template<typename T> void _print(vector<vector<T >> v) {
cerr << "{\n"; for (auto i : v) _print(i), cerr << "\n"; cerr << " }";
}
#endif
using ll = long long;using ull = unsigned long long;
using DB=double;using LD=long double;
// using i128 = __int128;
using pdd = pair<DB,DB>;using plb = pair<ll,bool>;
using pll = pair<ll,ll>;using vll=vector<ll>;using vb=vector<bool>;
using tll = tuple<ll,ll,ll>;using vii=vector<int>;
using vpll = vector<pll>;using vtll = vector<tll>;
using vdb = vector<DB>;using vc=vector<char>;
using arr3 = array<ll,3> ;using arr2 = array<ll,2>;
using CD=complex<double>;
static constexpr ll MAXN=(ll)1e6+10,INF=(ll)1e17+3; // 1e17+3是素数 1e18+9是素数
static constexpr ll mod=(ll)1e9+7; // 998244353;
static constexpr double eps=1e-8;const double pi=acos(-1.0);
ll N,M,Q,X,K,T,lT;
inline void __();
signed main()
{
ios::sync_with_stdio(false);
cin.tie(0);cout.tie(0);
cin>>lT;
while(lT--)
__();
return 0;
}
/*
只进行一次这个操作以后,要求数组和最大
呃,实话实说,我看了一眼题解,看到了二分答案。
你说这个会是检验这个数组和能不能达到吗?
其实我们会发现,这个也没有那么容易
或者说,我们确定一个数字为中位数以后,检查他是否可行
以及快速O(1)算出答案,可不可行那?
*/
inline void __(){
cin>>N;
vll A(N+5);
FOR(i,1,N){
cin>>A[i];
}
// 发现A的顺序不重要,因此我们进行排序
sort(A.begin()+1,A.begin()+1+N);
vll Sum(N+5);
FOR(i,1,N){
Sum[i]=Sum[i-1]+A[i];
}
// 我们会发现一个瓶颈就是这个O(1)之所以不行,就是因为
// 就是小的数字我们当然是囊括越多小的越好
// 但是大的数字我们又希望囊括越少大的数字越好
// 这个时候就产生了矛盾,我们要怎样最优化这个问题那?
// 我们注意到
// profit=len*A[i]-(A[1]+A[2]+A[3]+...+A[len])+(len*A[i]-(A[i+1]+A[i+2]+...+A[i+len]) )
// 2*A[i]-A[i+1]-A[1],2*A[i]-A[i+2]-A[2]
// 不难发现这个是单调下降的,因此用二分就行了
ll ans=Sum[N];
#ifdef LOCAL
_print(Sum);
#endif
FOR(i,2,N){
ll big=N-i;
ll l=1,r=big;
while(l<r){
ll mid=l+r+1>>1;
ll p=2*A[i]-A[mid+i]-A[mid];
if(p>=0){
l=mid;
}else{
r=mid-1;
}
}
if(l==r){
ll lans=l*A[i]*2-Sum[l]-(Sum[i+l]-Sum[i+1-1])+Sum[N];
ans=max(lans,ans);
}
}
cout<<ans<<"\n";
}
/*
AC
https://www.codechef.com/viewsolution/1190317643
1
2
3 4
1
3
4 3 1
*/
```
:::
## 心路历程(WA,TLE,MLE……)